unit EmployeesListU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Mask, DBCtrls, Grids, DBGrids, Db, DBTables, ExtCtrls, DBCGrids,
  CheckLst, Buttons;

type
  TEmployeesList = class(TForm)
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    GroupBox1: TGroupBox;
    DBMemo1: TDBMemo;
    ContGroup: TGroupBox;
    AddressBox: TDBMemo;
    Label7: TLabel;
    Label8: TLabel;
    PhoneNoBox: TDBMemo;
    Query: TQuery;
    CityQuery: TQuery;
    CitySource: TDataSource;
    DegreeSource: TDataSource;
    DegreeQuery: TQuery;
    DegreeQueryEmployeeID: TIntegerField;
    DegreeQueryDegreeID: TIntegerField;
    DegreeQueryMajor: TStringField;
    DegreeQueryID: TIntegerField;
    DegreeQueryTitle: TStringField;
    Label14: TLabel;
    Label13: TLabel;
    DBMemo2: TDBMemo;
    DBGrid3: TDBGrid;
    Label12: TLabel;
    DBGrid2: TDBGrid;
    Label11: TLabel;
    Label15: TLabel;
    Panel2: TPanel;
    BitBtn1: TBitBtn;
    GroupBox3: TGroupBox;
    Label3: TLabel;
    Label2: TLabel;
    ChildNoLabel: TLabel;
    Label6: TLabel;
    Label9: TLabel;
    SexBox: TDBEdit;
    AgeBox: TDBEdit;
    ChildNoBox: TDBEdit;
    DBEdit3: TDBEdit;
    DBEdit1: TDBEdit;
    DBCheckBox1: TDBCheckBox;
    MarriedBox: TDBCheckBox;
    AcceptButton: TBitBtn;
    ShiftBox1: TDBCheckBox;
    ShiftBox2: TDBCheckBox;
    ShiftBox3: TDBCheckBox;
    QueryID: TIntegerField;
    QueryPassword: TStringField;
    QueryFirstName: TStringField;
    QueryLastName: TStringField;
    QueryAge: TIntegerField;
    QuerySex: TStringField;
    QueryMarried: TBooleanField;
    QueryChildNumber: TIntegerField;
    QueryAddress: TStringField;
    QueryPhoneNumbers: TStringField;
    QueryEmployed: TBooleanField;
    QuerySalary: TIntegerField;
    QueryJob: TStringField;
    QueryExperienceYears: TIntegerField;
    QueryExperties: TStringField;
    QueryResume: TMemoField;
    QueryShift1: TBooleanField;
    QueryShift2: TBooleanField;
    QueryShift3: TBooleanField;
    QueryFound: TBooleanField;
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure AcceptButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  EmployeesList: TEmployeesList;

implementation

{$R *.DFM}

uses
  Global;

procedure TEmployeesList.DataSource1DataChange(Sender: TObject;
  Field: TField);
begin
  CityQuery.Filter := 'EmployeeID = ' + IntToStr(Query.Fields.FieldByName('ID').AsInteger);
  DegreeQuery.Filter := 'EmployeeID = ' + IntToStr(Query.Fields.FieldByName('ID').AsInteger);
  ChildNoBox.Enabled := MarriedBox.Checked;
  ChildNoLabel.Enabled := MarriedBox.Checked;
end;

procedure TEmployeesList.BitBtn1Click(Sender: TObject);
begin
  Close;
end;

procedure TEmployeesList.FormShow(Sender: TObject);
var
  S: string;
begin
  DegreeQuery.Active := True;
  CityQuery.Active := True;
  if Global.Caption <> '' then
    Caption := Global.Caption
  else
    Caption := 'Employees';
  if Global.isSearch then
  begin
    ContGroup.Visible := showContact or (Global.WhoAmI = 'SysAdmin');
    AcceptButton.Visible := not Global.isReport;
  end
  else
  begin
    ContGroup.Visible := True;
    AcceptButton.Visible := False;
  end;
  if Global.SQL = '' then
    S := 'select * from Employee where Found = false;'
  else
    S := Global.SQL;
  Query.SQL.Clear;
  Query.SQL.Add(S);
  Query.Filter := Global.Filter;
  Query.Active := True;
  if Global.isSearch and (Query.Fields.FieldByName('ID').AsInteger <= 0) then
    Caption := 'No employee found';
end;

procedure TEmployeesList.AcceptButtonClick(Sender: TObject);
begin
  Global.SREmployee := Query.Fields.FieldByName('ID').AsInteger;
  ModalResult := 3;
end;

end.

