unit EmployersListU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, DBCtrls, Mask, StdCtrls, Buttons, ExtCtrls, Grids, DBGrids;

type
  TEmployersList = class(TForm)
    ErGrid: TDBGrid;
    GroupBox1: TGroupBox;
    Label14: TLabel;
    Label13: TLabel;
    Label11: TLabel;
    Label15: TLabel;
    DBMemo1: TDBMemo;
    DBMemo2: TDBMemo;
    Panel2: TPanel;
    ContGroup: TGroupBox;
    Label7: TLabel;
    Label8: TLabel;
    AddressBox: TDBMemo;
    PhoneNoBox: TDBMemo;
    OKButton: TBitBtn;
    GroupBox3: TGroupBox;
    Label3: TLabel;
    Label2: TLabel;
    Label6: TLabel;
    Label9: TLabel;
    SexBox: TDBEdit;
    MinAgeBox: TDBEdit;
    DBEdit3: TDBEdit;
    DBEdit1: TDBEdit;
    DataSource1: TDataSource;
    ErQuery: TQuery;
    JobSource: TDataSource;
    JobGrid: TDBGrid;
    Label1: TLabel;
    DBEdit2: TDBEdit;
    DBEdit4: TDBEdit;
    DBEdit5: TDBEdit;
    Label4: TLabel;
    Label5: TLabel;
    DBEdit6: TDBEdit;
    Label10: TLabel;
    DBEdit7: TDBEdit;
    DBMemo3: TDBMemo;
    Label12: TLabel;
    ErQueryID: TIntegerField;
    ErQueryPassword: TStringField;
    ErQueryTitle: TStringField;
    ErQueryAddress: TStringField;
    ErQueryTel: TStringField;
    ErQueryRegistrationNo: TStringField;
    JobQuery: TQuery;
    AcceptButton: TBitBtn;
    ShiftBox1: TDBCheckBox;
    ShiftBox2: TDBCheckBox;
    ShiftBox3: TDBCheckBox;
    CancelButton: TBitBtn;
    JobQueryID: TIntegerField;
    JobQueryEmployerID: TIntegerField;
    JobQueryRequests: TSmallintField;
    JobQueryJob: TStringField;
    JobQueryLocation: TStringField;
    JobQuerySalary: TIntegerField;
    JobQueryShift1: TBooleanField;
    JobQueryShift2: TBooleanField;
    JobQueryShift3: TBooleanField;
    JobQueryMinAge: TSmallintField;
    JobQueryMaxAge: TSmallintField;
    JobQuerySex: TStringField;
    JobQueryMinExperienceYears: TSmallintField;
    JobQueryDegree: TIntegerField;
    JobQueryMajor: TStringField;
    JobQueryExperties: TStringField;
    JobQueryPriorities: TMemoField;
    JobQueryNotes: TMemoField;
    JobQueryFilled: TSmallintField;
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
    procedure OKButtonClick(Sender: TObject);
    procedure JobSourceDataChange(Sender: TObject; Field: TField);
    procedure FormShow(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure AcceptButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  EmployersList: TEmployersList;

implementation

{$R *.DFM}

uses
  Global;

procedure TEmployersList.DataSource1DataChange(Sender: TObject;
  Field: TField);
begin
  if not Global.isSearch then
    JobQuery.Filter := 'EmployerID = ' + IntToStr(ErQuery.Fields.FieldByName('ID').AsInteger);
end;

procedure TEmployersList.OKButtonClick(Sender: TObject);
begin
  Global.SRJob := JobQuery.Fields.FieldByName('ID').AsInteger;
  if isJobSelect then
    ModalResult := 4
  else
    ModalResult := 1;
end;

procedure TEmployersList.JobSourceDataChange(Sender: TObject;
  Field: TField);
begin
  if Global.isSearch then
    ErQuery.Filter := 'ID = ' + IntToStr(JobQuery.Fields.FieldByName('EmployerID').AsInteger);
end;

procedure TEmployersList.FormShow(Sender: TObject);
var
  S, J: string;
begin
  if Global.Caption <> '' then
    Caption := Global.Caption
  else
    Caption := 'Employers';
  if Global.isJobSelect then
  begin
    OKButton.Caption := 'Select';
    CancelButton.Visible := True;
    OKButton.Cancel := False;
    JobGrid.SetFocus;
  end
  else
  begin
    OKButton.Caption := 'OK';
    CancelButton.Visible := false;
    OKButton.Cancel := True;
  end;
  if Global.isSearch then
  begin
    JobGrid.SetFocus;
    ContGroup.Visible := showContact or (Global.WhoAmI = 'SysAdmin');
    AcceptButton.Visible := not Global.isReport;
  end
  else
  begin
    ErGrid.SetFocus;
    ContGroup.Visible := True;
    AcceptButton.Visible := False;
  end;
  if Global.SQL = '' then
    S := 'Select * from Employer where Employer."Password"<>"out";'
  else
    S := Global.SQL;
  if Global.JobSQL = '' then
    J := 'select * from Job where Requests > 0;'
  else
    J := Global.JobSQL;
  ErQuery.SQL.Clear;
  ErQuery.SQL.Add(S);
  ErQuery.Filter := Global.Filter;
  ErQuery.Active := True;
  JobQuery.SQL.Clear;
  JobQuery.SQL.Add(J);
  JobQuery.Filter := Global.JobFilter;
  JobQuery.Active := True;
  if Global.isSearch then
    ErQuery.Filter := 'ID = ' + IntToStr(JobQuery.Fields.FieldByName('EmployerID').AsInteger)
  else
    JobQuery.Filter := 'EmployerID = ' + IntToStr(ErQuery.Fields.FieldByName('ID').AsInteger);
  if Global.isSearch and (JobQuery.Fields.FieldByName('ID').AsInteger <= 0) then
    Caption := 'No job found';
end;

procedure TEmployersList.BitBtn2Click(Sender: TObject);
begin
  Global.SRJob := JobQuery.Fields.FieldByName('ID').AsInteger;
  ModalResult := 4;
end;

procedure TEmployersList.AcceptButtonClick(Sender: TObject);
begin
  Global.SREmployer := ErQuery.Fields.FieldByName('ID').AsInteger;
  Global.SRJob := JobQuery.Fields.FieldByName('ID').AsInteger;
  ModalResult := 3
end;

end.

