unit NewEmployeeU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, DBCtrls, Mask, StdCtrls, Buttons, ExtCtrls, Grids, DBGrids;

type
  TNewEmployee = class(TForm)
    GroupBox1: TGroupBox;
    Label14: TLabel;
    Label13: TLabel;
    Label12: TLabel;
    Label15: TLabel;
    Panel2: TPanel;
    ShiftBox3: TCheckBox;
    ShiftBox1: TCheckBox;
    ShiftBox2: TCheckBox;
    GroupBox2: TGroupBox;
    Label7: TLabel;
    Label8: TLabel;
    BitBtn1: TBitBtn;
    GroupBox3: TGroupBox;
    Label3: TLabel;
    Label2: TLabel;
    ChildNoLabel: TLabel;
    Label6: TLabel;
    Label9: TLabel;
    SexBox: TComboBox;
    AgeBox: TEdit;
    ChildNoBox: TEdit;
    ExpYearsBox: TEdit;
    Label5: TLabel;
    Label10: TLabel;
    FNameBox: TEdit;
    LNameBox: TEdit;
    PasswordBox: TEdit;
    RePasswordBox: TEdit;
    Label1: TLabel;
    label132: TLabel;
    PhoneNoBox: TMemo;
    ExpertiesBox: TMemo;
    SrcLabel: TLabel;
    DstLabel: TLabel;
    IncludeBtn: TSpeedButton;
    IncAllBtn: TSpeedButton;
    ExcludeBtn: TSpeedButton;
    ExAllBtn: TSpeedButton;
    SrcList: TListBox;
    DstList: TListBox;
    MarriedBox: TCheckBox;
    EmployedBox: TCheckBox;
    Query: TQuery;
    QueryName: TStringField;
    BitBtn2: TBitBtn;
    DegreeBox: TComboBox;
    MajorBox: TEdit;
    Label4: TLabel;
    Label11: TLabel;
    AddButton: TButton;
    Query2: TQuery;
    Query2ID: TIntegerField;
    Query2Title: TStringField;
    SalaryBox: TEdit;
    AddressBox: TMemo;
    EmQuery: TQuery;
    GroupBox4: TGroupBox;
    JobBox: TEdit;
    CertificatesBox: TStringGrid;
    ResumeBox: TMemo;
    Label16: TLabel;
    Label17: TLabel;
    Query1: TQuery;
    procedure BitBtn1Click(Sender: TObject);
    procedure IncludeBtnClick(Sender: TObject);
    procedure ExcludeBtnClick(Sender: TObject);
    procedure IncAllBtnClick(Sender: TObject);
    procedure ExAllBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure AddButtonClick(Sender: TObject);
    procedure MarriedBoxClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure SetButtons;
    function GetFirstSelection(List: TCustomListBox): Integer;
    procedure SetItem(List: TListBox; Index: Integer);
  end;

var
  NewEmployee: TNewEmployee;

implementation

{$R *.DFM}

uses
  Global;

var
  Certs : Integer;

procedure MoveSelected(List: TCustomListBox; Items: TStrings);
var
  I: Integer;
begin
  for I := List.Items.Count - 1 downto 0 do
    if List.Selected[I] then
    begin
      Items.AddObject(List.Items[I], List.Items.Objects[I]);
      List.Items.Delete(I);
    end;
end;

procedure TNewEmployee.SetButtons;
var
  SrcEmpty, DstEmpty: Boolean;
begin
  SrcEmpty := SrcList.Items.Count = 0;
  DstEmpty := DstList.Items.Count = 0;
  IncludeBtn.Enabled := not SrcEmpty;
  IncAllBtn.Enabled := not SrcEmpty;
  ExcludeBtn.Enabled := not DstEmpty;
  ExAllBtn.Enabled := not DstEmpty;
end;

function TNewEmployee.GetFirstSelection(List: TCustomListBox): Integer;
begin
  for Result := 0 to List.Items.Count - 1 do
    if List.Selected[Result] then Exit;
  Result := LB_ERR;
end;

procedure TNewEmployee.SetItem(List: TListBox; Index: Integer);
var
  MaxIndex: Integer;
begin
  with List do
  begin
    SetFocus;
    MaxIndex := List.Items.Count - 1;
    if Index = LB_ERR then Index := 0
    else if Index > MaxIndex then Index := MaxIndex;
    Selected[Index] := True;
  end;
  SetButtons;
end;

procedure TNewEmployee.BitBtn1Click(Sender: TObject);
var
  I: Integer;
begin
  try
  begin
    if (FNameBox.Text = '') or (LNameBox.Text = '') or
      (PasswordBox.Text = '') or (RePasswordBox.Text = '') or
      (AgeBox.Text = '') or (ExpYearsBox.Text = '') or (SexBox.Text = '') or
      (MarriedBox.Checked and (ChildNoBox.Text = '')) then
      MessageDlg('Please fill the personal information first', mtError, [mbOK], 0)
    else if Length(PasswordBox.Text) < 5 then
      MessageDlg('Passwords should be at least 5 characters', mtError, [mbOK], 0)
    else if PasswordBox.Text <> RePasswordBox.Text then
      MessageDlg('Passwords mismatch', mtError, [mbOK], 0)
    else if not (StrToInt(AgeBox.Text) in [16..65]) then
      MessageDlg('Invalid Age field', mtError, [mbOK], 0)
    else if MarriedBox.Checked and not (StrToInt(ChildNoBox.Text) in [0..9]) then
      MessageDlg('Invalid Child No. field', mtError, [mbOK], 0)
    else if not (StrToInt(ExpYearsBox.Text) in [0..30]) then
      MessageDlg('Invalid Exprience Years field', mtError, [mbOK], 0)
    else if StrToInt(SalaryBox.Text) < 0 then
      MessageDlg('Invalid Salary field', mtError, [mbOK], 0)
    else if (PhoneNoBox.Text = '') then
      MessageDlg('Please fill the Phone Number(s) box first', mtError, [mbOK], 0)
    else if (JobBox.Text = '') then
      MessageDlg('Please fill the Job field', mtError, [mbOK], 0)
    else if DstList.Items.Count = 0 then
      MessageDlg('Please select at least one city', mtError, [mbOK], 0)
    else if not (ShiftBox1.Checked or ShiftBox2.Checked or ShiftBox3.Checked) then
      MessageDlg('Please select at least one shift', mtError, [mbOK], 0)
    else
    begin
      EmQuery.SQL.Clear;
      with EmQuery.SQL do
      begin
        Add('insert into employee ('
           +'Employee."Password",Employee."First Name",Employee."Last Name",'
           +'Age, Sex, Married, Employee."Child Number", Address, Employee."Phone Number(s)",'
           +'Employed, Salary, Job, ExperienceYears, Experties, Resume, Shift1, Shift2, Shift3, Found'
           +') values ('
           +S(PasswordBox.Text)+','
           +S(FNameBox.Text)+','
           +S(LNameBox.Text)+','
           +S(AgeBox.Text)+','
           +S(SexBox.Text)+','
           +B(MarriedBox.Checked)+','
           +S(ChildNoBox.Text)+','
           +S(AddressBox.Text)+','
           +S(PhoneNoBox.Text)+','
           +B(EmployedBox.Checked)+','
           +S(SalaryBox.Text)+','
           +S(JobBox.Text)+','
           +S(ExpYearsBox.Text)+','
           +S(ExpertiesBox.Text)+','
           +S(ResumeBox.Text)+','
           +B(ShiftBox1.Checked)+','
           +B(ShiftBox2.Checked)+','
           +B(ShiftBox3.Checked)+','
           +B(false)
           +');');
      end;
      EmQuery.ExecSQL;
      EmQuery.Close;
      EmQuery.SQL.Clear;
      EmQuery.SQL.Add('select * from Employee;');
      EmQuery.Active := true;
      EmQuery.Last;
      Global.UserId := EmQuery.Fields.FieldByName('ID').AsInteger;
      Global.Password := EmQuery.Fields.FieldByName('Password').AsString;
      EmQuery.Close;
      with EmQuery do
      begin
        SQL.Clear;
        SQL.Add('insert into Employee_City (EmployeeID, City) values');
        SQL.Add('(0,"")');
        for I := 0 to DstList.Items.Count - 1 do
        begin
          SQL[1] := '('+IntToStr(Global.UserID)+',"'+DstList.Items.Strings[I]+'")';
          ExecSQL;
        end;
        Close;
      end;
      with EmQuery do
      begin
        SQL.Clear;
        SQL.Add('insert into Employee_Degree (EmployeeID, DegreeID, Major) values');
        SQL.Add('(0,0, "")');
        for I := 1 to Certs do
        begin
          Query2.Filter := 'Title='''+CertificatesBox.Cells[0, I]+'''';
          Query2.First;
          SQL[1] := '('+IntToStr(Global.UserID)+','+IntToStr(Query2.Fields.FieldByName('ID').AsInteger)+
                    ',"'+CertificatesBox.Cells[1, I]+'")';
          ExecSQL;
        end;
        Close;
      end;
      MessageDlg('Your User ID is "'+IntToStr(Global.UserID)+'",'+
                 'and your Password is "'+Global.Password+'", Remember them for later login',
                 mtWarning, [mbOK], 0);
      ModalResult := 1;
    end;
  end
  except
    on EConvertError do
      MessageDlg('Invalid value for integer fields', mtError, [mbOK], 0)
  end;
end;

procedure TNewEmployee.IncludeBtnClick(Sender: TObject);
var
  Index: Integer;
begin
  Index := GetFirstSelection(SrcList);
  MoveSelected(SrcList, DstList.Items);
  SetItem(SrcList, Index);
end;

procedure TNewEmployee.ExcludeBtnClick(Sender: TObject);
var
  Index: Integer;
begin
  Index := GetFirstSelection(DstList);
  MoveSelected(DstList, SrcList.Items);
  SetItem(DstList, Index);
end;

procedure TNewEmployee.IncAllBtnClick(Sender: TObject);
var
  I: Integer;
begin
  for I := 0 to SrcList.Items.Count - 1 do
    DstList.Items.AddObject(SrcList.Items[I],
      SrcList.Items.Objects[I]);
  SrcList.Items.Clear;
  SetItem(SrcList, 0);
end;

procedure TNewEmployee.ExAllBtnClick(Sender: TObject);
var
  I: Integer;
begin
  for I := 0 to DstList.Items.Count - 1 do
    SrcList.Items.AddObject(DstList.Items[I], DstList.Items.Objects[I]);
  DstList.Items.Clear;
  SetItem(DstList, 0);
end;

procedure TNewEmployee.FormShow(Sender: TObject);
var
  C: string;
  I: Integer;
begin
  FNameBox.Clear;
  LNameBox.Clear;
  MarriedBox.Checked := false;
  ChildNoBox.Enabled := false;
  ChildNoLabel.Enabled := false;
  EmployedBox.Checked := false;
  ShiftBox1.Checked := false;
  ShiftBox2.Checked := false;
  ShiftBox3.Checked := false;
  AgeBox.Clear;
  PasswordBox.Clear;
  RePasswordBox.Clear;
  ResumeBox.Clear;
  ExpertiesBox.Clear;
  AddressBox.Clear;
  PhoneNoBox.Clear;
  ChildNoBox.Clear;
  ExpYearsBox.Clear;
  MajorBox.Clear;
  SalaryBox.Clear;
  SrcList.Clear;
  DstList.Clear;
  DegreeBox.Clear;
  for I := 0 to CertificatesBox.RowCount - 1 do
    CertificatesBox.Rows[I].Clear;
  Query.Open;
  Query.First;
  while not Query.Eof do
  begin
    C := Query.Fields.FieldByName('Name').AsString;
    SrcList.Items.Add(C);
    Query.Next;
  end;
  Query.Close;
  Query2.Filter := '';
  Query2.Active := true;
  Query2.First;
  while not Query2.Eof do
  begin
    C := Query2.Fields.FieldByName('Title').AsString;
    DegreeBox.Items.Add(C);
    Query2.Next;
  end;
  CertificatesBox.Cells[0, 0] := 'Degree';
  CertificatesBox.Cells[1, 0] := 'Major';
  Certs := 0;
end;

procedure TNewEmployee.AddButtonClick(Sender: TObject);
begin
  if (DegreeBox.Text <> '') and
     (MajorBox.Text <> '') then
  begin
    Certs := Certs + 1;
    CertificatesBox.Row := Certs;
    CertificatesBox.Rows[Certs].Add(DegreeBox.Text);
    CertificatesBox.Rows[Certs].Add(MajorBox.Text);
    MajorBox.Text := '';
  end;
end;

procedure TNewEmployee.MarriedBoxClick(Sender: TObject);
begin
  if MarriedBox.Checked then
  begin
    ChildNoBox.Enabled := true;
    ChildNoLabel.Enabled := true;
  end
  else
  begin
    ChildNoBox.Enabled := false;
    ChildNoLabel.Enabled := false;
    ChildNoBox.Text := '';
  end;
end;

end.

