unit NewEmployerU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, Buttons, Grids, StdCtrls, ExtCtrls;

type
  TNewEmployer = class(TForm)
    TechGroup: TGroupBox;
    Label14: TLabel;
    Label13: TLabel;
    Label15: TLabel;
    Label4: TLabel;
    Label11: TLabel;
    Panel2: TPanel;
    ShiftBox3: TCheckBox;
    ShiftBox1: TCheckBox;
    ShiftBox2: TCheckBox;
    ExpertiesBox: TMemo;
    DegreeBox: TComboBox;
    MajorBox: TEdit;
    NotesBox: TMemo;
    ContGroup: TGroupBox;
    Label7: TLabel;
    Label8: TLabel;
    AddressBox: TMemo;
    PhoneNoBox: TMemo;
    NextButton: TBitBtn;
    GenGroup: TGroupBox;
    Label5: TLabel;
    Label10: TLabel;
    Label1: TLabel;
    label132: TLabel;
    TitleBox: TEdit;
    RegNoBox: TEdit;
    PasswordBox: TEdit;
    RePasswordBox: TEdit;
    CancelButton: TBitBtn;
    Query: TQuery;
    QueryName: TStringField;
    Query2: TQuery;
    Query2ID: TIntegerField;
    Query2Title: TStringField;
    EmQuery: TQuery;
    SalaryBox: TEdit;
    Label9: TLabel;
    Label6: TLabel;
    ExpYearsBox: TEdit;
    MaxAgeBox: TEdit;
    ChildNoLabel: TLabel;
    MinAgeBox: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    SexBox: TComboBox;
    Label12: TLabel;
    RequestsBox: TEdit;
    Label16: TLabel;
    PrioritiesBox: TMemo;
    Label17: TLabel;
    JobBox: TEdit;
    Label18: TLabel;
    LocationBox: TComboBox;
    AddButton: TButton;
    DoneButton: TBitBtn;
    procedure FormShow(Sender: TObject);
    procedure NextButtonClick(Sender: TObject);
    procedure AddButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  NewEmployer: TNewEmployer;

implementation

{$R *.DFM}

uses
  Global;

procedure TNewEmployer.FormShow(Sender: TObject);
var
  C: String;
begin
  TitleBox.Clear;
  RegNoBox.Clear;
  PasswordBox.Clear;
  RePasswordBox.Clear;
  AddressBox.Clear;
  PhoneNoBox.Clear;
  ShiftBox1.Checked := false;
  ShiftBox2.Checked := false;
  ShiftBox3.Checked := false;
  MinAgeBox.Text := '16';
  MaxAgeBox.Text := '65';
  NotesBox.Clear;
  ExpertiesBox.Clear;
  PrioritiesBox.Clear;
  ExpYearsBox.Clear;
  DegreeBox.Clear;
  MajorBox.Clear;
  SalaryBox.Clear;
  JobBox.Clear;
  RequestsBox.Text := '1';
  LocationBox.Clear;

  TechGroup.Enabled := False;
  AddButton.Enabled := False;
  DoneButton.Enabled := False;
  GenGroup.Enabled := True;
  ContGroup.Enabled := True;
  NextButton.Enabled := True;
  CancelButton.Enabled := True;

  Query.Open;
  Query.First;
  while not Query.Eof do
  begin
    C := Query.Fields.FieldByName('Name').AsString;
    LocationBox.Items.Add(C);
    Query.Next;
  end;
  Query.Close;
  Query2.Filter := '';
  Query2.Active := true;
  Query2.First;
  DegreeBox.Items.Add('-');
  while not Query2.Eof do
  begin
    C := Query2.Fields.FieldByName('Title').AsString;
    DegreeBox.Items.Add(C);
    Query2.Next;
  end;
  DegreeBox.Text := '-';
end;

procedure TNewEmployer.NextButtonClick(Sender: TObject);
begin
  try
  begin
    if (TitleBox.Text = '') or (RegNoBox.Text = '') or
      (PasswordBox.Text = '') or (RePasswordBox.Text = '') then
      MessageDlg('Please fill the general information first', mtError, [mbOK], 0)
    else if Length(PasswordBox.Text) < 5 then
      MessageDlg('Passwords should be at least 5 characters', mtError, [mbOK], 0)
    else if PasswordBox.Text <> RePasswordBox.Text then
      MessageDlg('Passwords mismatch', mtError, [mbOK], 0)
    else if (PhoneNoBox.Text = '') or (AddressBox.Text = '') then
      MessageDlg('Please fill the contact information first', mtError, [mbOK], 0)
    else
    begin
      EmQuery.SQL.Clear;
      with EmQuery.SQL do
      begin
        Add('insert into employer (');
        Add('Employer."Password", Title, Address, Tel, Employer."Registration No."');
        Add(') values (');
        Add('"'+PasswordBox.Text+'","'+TitleBox.Text+'",');
        Add('"'+AddressBox.Text+'","'+PhoneNoBox.Text+'",');
        Add('"'+RegNoBox.Text+'"');
        Add(');');
      end;
      EmQuery.ExecSQL;
      EmQuery.Close;
      EmQuery.SQL.Clear;
      EmQuery.SQL.Add('select * from Employer;');
      EmQuery.Active := true;
      EmQuery.Last;
      Global.UserId := EmQuery.Fields.FieldByName('ID').AsInteger;
      Global.Password := EmQuery.Fields.FieldByName('Password').AsString;
      EmQuery.Close;

      MessageDlg('Your User ID is "'+IntToStr(Global.UserID)+'",'+
                 'and your Password is "'+Global.Password+'", Remember them for later login',
                 mtWarning, [mbOK], 0);
      TechGroup.Enabled := True;
      AddButton.Enabled := True;
      DoneButton.Enabled := True;
      GenGroup.Enabled := False;
      ContGroup.Enabled := False;
      NextButton.Enabled := False;
      CancelButton.Enabled := False;
    end;
  end
  except
    on EConvertError do
      MessageDlg('Invalid value for integer fields', mtError, [mbOK], 0)
  end;
end;

procedure TNewEmployer.AddButtonClick(Sender: TObject);
var
  Deg: string;
begin
  try
  begin
    if not ((StrToInt(MinAgeBox.Text) in [16..65])
       and (StrToInt(MaxAgeBox.Text) in [16..65])
       and (StrToInt(MinAgeBox.Text) < StrToInt(MaxAgeBox.Text))) then
      MessageDlg('Invalid Age fields', mtError, [mbOK], 0)
    else if not (StrToInt(ExpYearsBox.Text) in [0..30]) then
      MessageDlg('Invalid Exprience Years field', mtError, [mbOK], 0)
    else if (SalaryBox.Text <> '') and (StrToInt(SalaryBox.Text) < 0) then
      MessageDlg('Invalid Salary field', mtError, [mbOK], 0)
    else if LocationBox.Text = '' then
      MessageDlg('Please select a Location', mtError, [mbOK], 0)
    else if not (ShiftBox1.Checked or ShiftBox2.Checked or ShiftBox3.Checked) then
      MessageDlg('Please select at least one shift', mtError, [mbOK], 0)
    else if (JobBox.Text = '') then
      MessageDlg('Please fill the Job field', mtError, [mbOK], 0)
    else if (S(DegreeBox.Text)='NULL') xor (S(MajorBox.Text)='NULL') then
      MessageDlg('Please fill both Degree and Major fields, or none of them', mtError, [mbOK], 0)
    else
    begin
      EmQuery.SQL.Clear;
      with EmQuery.SQL do
      begin
        Query2.Filter := 'Title='''+DegreeBox.Text+'''';
        Query2.First;
        Deg := IntToStr(Query2.Fields.FieldByName('ID').AsInteger);
        if Deg = '0' then
          Deg := '';
        Add('insert into job ('
           +'EmployerID, Requests, Job, Location, Salary, Shift1, Shift2, Shift3,'
           +'Job."Min. Age", Job."Max. Age", Sex, Job."Min. Experience Years",'
           +'Degree, Major, Experties, Priorities, Notes, Filled'
           +') values ('
           +S(IntToStr(Global.UserID))+','
           +S(RequestsBox.Text)+','
           +S(JobBox.Text)+','
           +S(LocationBox.Text)+','
           +S(SalaryBox.Text)+','
           +B(ShiftBox1.Checked)+','
           +B(ShiftBox2.Checked)+','
           +B(ShiftBox3.Checked)+','
           +S(MinAgeBox.Text)+','
           +S(MaxAgeBox.Text)+','
           +S(SexBox.Text)+','
           +S(ExpYearsBox.Text)+','
           +S(Deg)+','
           +S(MajorBox.Text)+','
           +S(ExpertiesBox.Text)+','
           +S(PrioritiesBox.Text)+','
           +S(NotesBox.Text)+','
           +S('0')
           +');');
      end;
      EmQuery.ExecSQL;
      EmQuery.Close;
      MessageDlg('Job added successfully', mtInformation, [mbOK], 0);
      NotesBox.Clear;
      ExpertiesBox.Clear;
      PrioritiesBox.Clear;
      JobBox.Clear;
      RequestsBox.Text := '1';
    end;
  end
  except
    on EConvertError do
      MessageDlg('Invalid value for integer fields', mtError, [mbOK], 0)
  end;
end;

end.

