unit UserHomeU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Db, DBTables;

type
  TUserHome = class(TForm)
    Button1: TButton;
    SearchButton: TButton;
    Button3: TButton;
    Memo: TMemo;
    Button4: TButton;
    Query: TQuery;
    CityQuery: TQuery;
    DegreeQuery: TQuery;
    CityQueryEmployeeID: TIntegerField;
    CityQueryCity: TStringField;
    DegreeQueryEmployeeID: TIntegerField;
    DegreeQueryDegreeID: TIntegerField;
    DegreeQueryMajor: TStringField;
    ReportQuery: TQuery;
    procedure FormShow(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure SearchButtonClick(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
    function WQ(d: boolean; f, o, s: string): string;
  public
    { Public declarations }
  end;

var
  UserHome: TUserHome;

implementation

{$R *.DFM}

uses
  Global, EmployeesListU, EmployersListU, ReportU;

procedure TUserHome.FormShow(Sender: TObject);
begin
  Caption := Global.UserTitle + ' - Home';
end;

procedure TUserHome.Button4Click(Sender: TObject);
begin
  Close;
end;

procedure TUserHome.Button1Click(Sender: TObject);
begin
  if Found then
  begin
    MessageDlg('You can only read your reports, and then your UserID will expire', mtError, [mbOK], 0);
    Exit;
  end;
  Global.ResetVars;
  Global.Caption := Global.UserTitle+' - Profile';
  Global.Filter := 'ID = ' + IntToStr(Global.UserID);
  if Employee then
    EmployeesList.ShowModal
  else
    EmployersList.ShowModal;
end;

function TUserHome.WQ(d: boolean; f, o, s: string): string;
begin
  WQ := Global.W(d, f, o, Query.FieldByName(s).AsString);
end;

procedure TUserHome.SearchButtonClick(Sender: TObject);
var
  C, M, C2, QueryS: string;
  I: Integer;
  HaveDeg: Boolean;
begin
  Global.ResetVars;
  if Found then
  begin
    MessageDlg('You can only read your reports, and then your UserID will expire', mtError, [mbOK], 0);
    Exit;
  end;
  if Global.Employee then
  begin
    CityQuery.Filter := 'EmployeeID='+IntToStr(Global.UserID);
    DegreeQuery.Filter := 'EmployeeID='+IntToStr(Global.UserID);
    CityQuery.Active := true;
    DegreeQuery.Active := true;
    Query.SQL.Clear;
    Query.SQL.Add('select * from Employee'
                  +' where ID='+IntToStr(Global.UserID)+';');
    Query.Active := true;
    QueryS := 'select * from Job where Requests > 0 '
              +' and '+WQ(true, 'Job', 'like', 'Job')
              +' and '+WQ(true, 'Salary', '>=', 'Salary');
    QueryS := QueryS + ' and (0=1 ';
    CityQuery.First;
    C := 'asdfasdfx';
    while true do
    begin
      C2 := C;
      C := CityQuery.Fields.FieldByName('City').AsString;
      if C2 = C then
        break;
      QueryS := QueryS + ' or ' + W(false, 'Location', '=', C);
      CityQuery.Next;
    end;
    QueryS := QueryS + ') and (0=1 ';
    DegreeQuery.First;
    C := 'asdfasdfx';
    while not DegreeQuery.Eof do
    begin
      C2 := C;
      C := IntToStr(DegreeQuery.Fields.FieldByName('DegreeID').AsInteger);
      if C2 = C then
        break;
      M := DegreeQuery.Fields.FieldByName('Major').AsString;
      QueryS := QueryS + ' or '
                +'(1=1 and '+W(true, 'Degree', '>=', C)+' and '+W(true, 'Major', 'like', M)+')';
      DegreeQuery.Next;
    end;
    QueryS := QueryS + ') and (0=1 ';
    if Query.Fields.FieldByName('Shift1').AsBoolean then
      QueryS := QueryS + ' or ' + W(false, 'Shift1', '=', 'true');
    if Query.Fields.FieldByName('Shift2').AsBoolean then
      QueryS := QueryS + ' or ' + W(false, 'Shift2', '=', 'true');
    if Query.Fields.FieldByName('Shift3').AsBoolean then
      QueryS := QueryS + ' or ' + W(false, 'Shift3', '=', 'true');
    QueryS := QueryS + ')';
    QueryS := QueryS
              +' and '+WQ(true,'Job."Min. Age"', '<=', 'Age')
              +' and '+WQ(true,'Job."Max. Age"', '>=', 'Age')
              +' and '+WQ(true,'Sex', '=', 'Sex')
              +' and '+WQ(true,'Job."Min. Experience Years"', '<=', 'ExperienceYears')
              +' and '+WQ(true,'Experties', 'like', 'Experties')
              +';';
    Query.Close;
    CityQuery.Close;
    DegreeQuery.Close;

    Global.JobSQL := QueryS;
    Global.isSearch := True;
    if EmployersList.ShowModal = 3 then
    begin
      Global.SREmployee := Global.UserID;
      Global.Caption := 'Search results';
      Report.SendReport(SREmployee, SREmployer, SRJob);
    end;
  end
  else
  begin
    Global.isJobSelect := True;
    Global.Filter := 'ID = ' + IntToStr(Global.UserID);
    Global.Caption := 'Job selection';
    if EmployersList.ShowModal < 0 then
      Exit;
    if SRJob <= 0 then
      Exit;

    Query.SQL.Clear;
    Query.SQL.Add('select * from Job'
                  +' where ID='+IntToStr(Global.SRJob)+';');
    Query.Active := true;
    I := Global.SRJob;
    Global.ResetVars;
    Global.SRJob := I;
    HaveDeg := Query.FieldByName('Degree').AsInteger > 0;
    QueryS := 'select * from Employee E, Employee_City C ';
    if HaveDeg then
      QueryS := QueryS + ', Employee_Degree D ';
    QueryS := QueryS
              +' where Found = "false" and E.ID = C.EmployeeID ';
    if HaveDeg then
      QueryS := QueryS + ' and E.ID = D.EmployeeID ';
    QueryS := QueryS
              +' and '+WQ(true, 'Job', 'like', 'Job')
              +' and '+WQ(true, 'Salary', '<=', 'Salary')
              +' and '+WQ(true, 'City', '=', 'Location');
    QueryS := QueryS + ' and (0=1 ';
    if Query.Fields.FieldByName('Shift1').AsBoolean then
      QueryS := QueryS + ' or ' + W(false, 'Shift1', '=', 'true');
    if Query.Fields.FieldByName('Shift2').AsBoolean then
      QueryS := QueryS + ' or ' + W(false, 'Shift2', '=', 'true');
    if Query.Fields.FieldByName('Shift3').AsBoolean then
      QueryS := QueryS + ' or ' + W(false, 'Shift3', '=', 'true');
    QueryS := QueryS + ')';
    QueryS := QueryS
              +' and '+WQ(true,'Age', '>=', 'Min. Age')
              +' and '+WQ(true,'Age', '<=', 'Max. Age')
              +' and '+WQ(true,'Sex', '=', 'Sex')
              +' and '+WQ(true,'ExperienceYears', '>=', 'Min. Experience Years')
              +' and '+WQ(true,'Experties', 'like', 'Experties');
    if HaveDeg then
      QueryS := QueryS
                +' and '+WQ(true,'DegreeID', '>=', 'Degree')
                +' and '+WQ(true,'Major', 'like', 'Major');
    QueryS := QueryS+';';
    Query.Close;
    CityQuery.Close;
    DegreeQuery.Close;

    Global.SQL := QueryS;
    Global.isSearch := True;
    Global.Caption := 'Search results';
    if EmployeesList.ShowModal = 3 then
    begin
      Global.SREmployer := Global.UserID;
      Report.SendReport(SREmployee, SREmployer, SRJob);
    end;
  end;
end;

procedure TUserHome.Button3Click(Sender: TObject);
begin
  Global.ResetVars;
  with ReportQuery do
  begin
    SQL.Clear;
    SQL.Add('select * from Report '
           +'where '+WhoAmI+'ID='+IntToStr(Global.UserID)+' and '
           +'Report."For"="'+Global.WhoAmI+'";');
    Active := true;
  end;
  if not ReportQuery.EOF then
    Report.ShowModal
  else
    MessageDlg('You have no reports', mtError, [mbOK], 0);
  if Found then
    with ReportQuery do
    begin
      Close;
      SQL.Clear;
      SQL.Add('update '+WhoAmI+' set '+WhoAmI+'."Password"="out" where ID='+IntToStr(UserID)+';');
      ExecSQL;
      MessageDlg('You have no request, so your account has been expired.', mtInformation, [mbOK], 0);
    end;
  ReportQuery.Close;
end;

end.

